<?php
use Projectify\Projectify_Helper;

class projectifyCarouselFullBeta {

	public static $args;

	/**
	 * Initiate the shortcode
	 */
	public function __construct() {
		
		add_shortcode( 'pjfy_carousel_full_beta', array( $this, 'render' ) );

	}

	function render( $args, $content = '') {
		

		$defaults = shortcode_atts( array (
			 'post_type'  					=> 'post',
			 'post_tax'   					=> '',
			 'post_terms' 					=> '',
			 'post_number' 					=> '',
			 'post_offset' 					=> '',
			 'cfb_category_show' 			=> '',
			 'cfb_nav_types' 				=> '',
			 'cfb_title_holder_type'		=> '',
			 'cfb_title_holder_position'	=> '',
			 'cfb_columns_number'			=> '',
			 'cfb_autoplay_switch' 			=> '',
			 'cfb_autoplay_time' 			=> '',
			 'pjfy_lightbox'				=> '',
			 'fn_page_include'				=> '',
			 'included_posts'				=> '',
		), $args );
		
		extract( $defaults );

		self::$args = $defaults;

		$fn_post_offset 			= $args['post_offset'];
		
		$query_args = array(
			'post_type' 			=> $args['post_type'],
			'offset' 				=> $fn_post_offset,
			'posts_per_page' 		=> $args['post_number'],
			'post_status' 			=> 'publish',
			'order' 				=> $args['post_order'],
			'orderby' 				=> $args['post_orderby'],
		);
		
		if($included_posts != ''){
			$included_posts = explode( ',', $included_posts );
		}else{
			$included_posts = array();
		}
		$query_args['post__in'] 	= $included_posts;
		
		
		$post_type 			= $args['post_type'];
		$fn_page_include 	= $args['fn_page_include'];
		if($post_type == 'page'){
			if($fn_page_include == 'featured_pages'){
				$query_args['meta_query'][] = array(
					'key'       => 'pjfy-meta-box-featured',
					'value'     => 'true',
					'compare'   => '==',
				);
			}
		}
			
		
		$categories = $args['post_terms'];
		
		// since v2.3
		if($categories != ''){
			$categories = explode( ',', $categories );
			$oldArray	= array();
			$count		= 0;
			$newArray	= array();
			foreach($categories as $cat){
				if (strpos($cat, '______') !== false) {
					$cat = explode('______', $cat);
					if(array_key_exists($cat[1],$newArray)){
						array_push($newArray[$cat[1]],$cat[0]);
					}else{
						$newArray[$cat[1]] = array($cat[0]);
					}
				}else{
					$oldArray[] = $cat;
				}
			}
			if(!empty($newArray)){
				foreach($newArray as $taxonomy => $terms){
					$count++;
					if($count > 1){
						$query_args['tax_query']['relation'] = 'OR';
					}
					$query_args['tax_query'] = array(
						array(
							'taxonomy' 	=> $taxonomy,
							'field' 	=> 'slug',
							'terms' 	=> $terms
						)
					);
				}
			}
			if(!empty($oldArray)){
				if($count > 1){
					$query_args['tax_query']['relation'] = 'OR';
				}
				$query_args['tax_query'] = array(
					array(
						'taxonomy' 	=> $args['post_tax'],
						'field' 	=> 'slug',
						'terms' 	=> $oldArray
					)
				);
			}	
		}
		
		
		$projectify_post_loop = new WP_Query($query_args);
		if($args['cfb_nav_types'] == 'square'){
			$spanc = '<span class="c"></span>';
		}else{
			$spanc = '';
		}
		$arrow			= '<span><span class="a"></span><span class="b"></span>'.$spanc.'</span>';
		$owl_control 	= '<div class="owl_control"><div class="fn_prev">'.$arrow.'</div><div class="fn_next">'.$arrow.'</div></div>';
		
		$autoplay_time = $args['cfb_autoplay_time'];
		$autoplay_switch = $args['cfb_autoplay_switch'];
		
		if($pjfy_lightbox === 'enable'){
			$parentLight = 'projectify_fn_lightbox';
			$childLight	 = 'lightbox';
		}else{
			$parentLight = '';
			$childLight	 = '';
		}
		
		$html = Projectify_Helper::projectify_open_wrap();
		
		$html .= '<div class="full_carousel_version"><div class="projectify_carousel_full_beta projectify_fn_miniboxes '.$parentLight.'" data-columns-number="'.$args['cfb_columns_number'].'" data-category-show="'.$args['cfb_category_show'].'" data-nav-types="'.$args['cfb_nav_types'].'" data-title-holder-animation="'.$args['cfb_title_holder_type'].'" data-title-holder-position="'.$args['cfb_title_holder_position'].'" data-autoplay-switch="'.$args['cfb_autoplay_switch'].'" data-autoplay-time="'.$args['cfb_autoplay_time'].'">'.$owl_control.'<div class="owl-carousel">';
		
		// foreach
		foreach ( $projectify_post_loop->posts as $fn_post ) {
			setup_postdata( $fn_post );
			$post_id 			= $fn_post->ID;
			$post_permalink 	= get_permalink($post_id);
			$post_taxonomy		= Projectify_Helper::post_taxanomy($args['post_type']);
			$post_cats			= '';
			if($args['post_type'] != 'page'){
				$post_cats			= Projectify_Helper::post_term_list($post_id, $post_taxonomy[0], false, 2, ', ');
			}
			
			$image 				= get_the_post_thumbnail_url( $post_id, 'full' );
			
			if($pjfy_lightbox === 'enable'){
				$imageURLThumb 	= get_the_post_thumbnail_url( $post_id, 'thumbnail' );
				$lightboxImg	= '<img class="pjfy_light_img" src="'.$imageURLThumb.'" alt="" />';
				$link			= '';
			}else{
				$lightboxImg 	= '';
				$link			= 'href="'.$post_permalink.'"';
			}
			
			$html .= '<div class="item">';
				$html .= $lightboxImg;
				$html .= '<a class="projectify__full_link '.$childLight.'" '.$link.' data-src="'.$image.'"></a>';
				$html .= '<div class="img_holder" data-bg-img="'.$image.'"></div>';
				$html .= '<div class="title_holder">';
					$html .= '<p><span>'.$post_cats.'</span></p>';
					$html .= '<h3><a href="'.$post_permalink.'">'.$fn_post->post_title.'</a></h3>';
				$html .= '</div>';
			$html .= '</div>';
			wp_reset_postdata();
		}
		$html .= '</div></div></div>';
		$html .= Projectify_Helper::projectify_close_wrap();

		return $html;

	}
	

}

new projectifyCarouselFullBeta();